/*******************************************************************************

  PointList for DIMIN Viewer n5 (DIV5)

  Programmer: Dima V. Fedorov Levit <dimin@dimin.net> <http://www.dimin.net/>

  History:
    06/23/2004 23:37 - First Creation

*******************************************************************************/

#include "DIVPointList.h"

#include <vector>
#include <algorithm>

//using namespace std;


//******************************************************************************
// sort by
//******************************************************************************

struct sort_by_x
{
  bool operator()(const TPoint& p1, const TPoint& p2)
  {
    if (p1.x > p2.x) return false;
    if (p1.x < p2.x) return true;
    //if (p1.x == p2.x)
    else
    {
      if (p1.y > p2.y) return false;
      else
      return true;
    }   
  }
};

struct sort_by_y
{
  bool operator()(const TPoint& p1, const TPoint& p2)
  {
    if (p1.y > p2.y) return false;
    if (p1.y < p2.y) return true;
    //if (p1.y == p2.y)
    else
    {
      if (p1.x > p2.x) return false;
      else
      return true;
    }   
  }
};

//******************************************************************************
// TPointList
//******************************************************************************


TDivPointList::TDivPointList()
{

}

void TDivPointList::loadFromArray(TPoint *a, int count)
{
  this->clear();
  this->reserve( count );
  
  int i;
  for (i=0; i<count; ++i)
    this->push_back( a[i] );
}

void TDivPointList::sortByX()
{
  std::sort( this->begin(), this->end(), sort_by_x() );
}

void TDivPointList::sortByY()
{
  std::sort( this->begin(), this->end(), sort_by_y() );
}

void TDivPointList::saveToText( char *fileName )
{
  int i;
  FILE *stream = fopen( fileName, "wb" );
  TPoint p;
  for (i=0; i<this->size(); ++i)
  {
    p = this->at(i);
    fprintf(stream, "[%d,%d] ", p.x, p.y );
  }
}

void TDivPointList::rowBegEnd(int y, int &lBegin, int &lEnd)
{
  if (this->size() <= 0) return;
  this->sortByY();

  lBegin = -1;
  lEnd   = -2;
  // Find x1
  int i=0;
  TPoint p;
  while ( i<this->size() )
  {
    p = this->at(i);
    if (p.y == y)
    {
      lBegin = p.x;
      break;
    }
    i++;
  }
  
  while ( ( i<this->size() ) && (p.y == y) )
  {
    p = this->at(i);
    if (p.y == y) lEnd = p.x;
    i++;
  }
}





